stages:
  - build
  - run

services:
  - docker:19.03.12-dind

variables:
  # project id for run job where we will execute pipeline
  RUN_PROJECT_ID: "33181799"

build_prod:
  stage: build
  tags:
    - jw_docker_executor
  environment:
    name: prod
  image: docker:19.03.12
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY/$CI_PROJECT_PATH
  script:
    - docker build -t ${CI_REGISTRY_IMAGE}:app_${CI_ENVIRONMENT_NAME}_${CI_COMMIT_SHORT_SHA} . | tee docker_build.log
    - docker push ${CI_REGISTRY_IMAGE}:app_${CI_ENVIRONMENT_NAME}_${CI_COMMIT_SHORT_SHA}
    - docker build -t ${CI_REGISTRY_IMAGE}:nginx -f Dockerfile_nginx .
    - docker push ${CI_REGISTRY_IMAGE}:nginx
  artifacts:
    paths:
      - docker_build.log
  rules:
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: always

build_dev:
  stage: build
  tags:
    - jw_docker_executor
  environment:
    name: dev
  image: docker:19.03.12
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY/$CI_PROJECT_PATH
  script:
    - docker build -t ${CI_REGISTRY_IMAGE}:app_${CI_ENVIRONMENT_NAME}_${CI_COMMIT_SHORT_SHA} . | tee docker_build.log
    - docker push ${CI_REGISTRY_IMAGE}:app_${CI_ENVIRONMENT_NAME}_${CI_COMMIT_SHORT_SHA}
    - docker build -t ${CI_REGISTRY_IMAGE}:nginx -f Dockerfile_nginx .
    - docker push ${CI_REGISTRY_IMAGE}:nginx
  artifacts:
    paths:
      - docker_build.log
  rules:
    - if: '$CI_COMMIT_REF_NAME == "dev"'
      when: always

run_prod:
  stage: run
  tags:
    - juneway
  variables:
    CI_NGINX_PORT: 8000
    APP_IMAGE_NAME: ${CI_REGISTRY_IMAGE}:app_${CI_ENVIRONMENT_NAME}_${CI_COMMIT_SHORT_SHA}
  script:
    - > # create new pipeline in run project and obtain it's ID
      export NEW_PPL_ID=$(curl
      --request POST -s --header "PRIVATE-TOKEN: ${ACCESS_TOKEN}"
      "https://gitlab.com/api/v4/projects/${RUN_PROJECT_ID}/pipeline?ref=master"
      --form "variables[][key]=APP_IMAGE" form "variables[][variable-type]=env_var" --form "variables[][value]=${APP_IMAGE_NAME}"
      --form "variables[][key]=NGINX_PORT" form "variables[][variable-type]=env_var" --form "variables[][value]=${CI_NGINX_PORT}"
      | /home/gitlab-runner/.nvm/versions/node/v16.13.2/bin/fx "_=>_.id")
    - > # get the first manual job in pipeline which we obtain in previous step
      export MANUAL_JOB_ID=$(curl
      -s --header "PRIVATE-TOKEN: ${ACCESS_TOKEN}"
      "https://gitlab.com/api/v4/projects/${RUN_PROJECT_ID}/pipelines/${NEW_PPL_ID}/jobs?scope[]=manual"
      | /home/gitlab-runner/.nvm/versions/node/v16.13.2/bin/fx "_=>_[0].id")
    - > # play manual job which we found in previous step. Job will execute with params which set on first step
      curl --request POST --header "PRIVATE-TOKEN: ${ACCESS_TOKEN}"
      "https://gitlab.com/api/v4/projects/${RUN_PROJECT_ID}/jobs/$MANUAL_JOB_ID/play"
  environment:
    name: prod
  rules:
    - if: '$CI_COMMIT_REF_NAME == "master"'
      when: always

run_dev:
  stage: run
  tags:
    - juneway
  variables:
    CI_NGINX_PORT: 8001
  script:
    - 'curl --header "PRIVATE-TOKEN: ${ACCESS_TOKEN}" "https://gitlab.com/api/v4/projects/${RUN_PROJECT_ID}/pipelines" | jq ".[]"'
  environment:
    name: dev
  rules:
    - if: '$CI_COMMIT_REF_NAME == "dev"'
      when: always
